{{
┌──────────────────────────────────────────────────────────────────────────────────────────────────────┐
│ Author: Dietmar Uhlig                                                                                │
│ Copyright (c) 2015 Dietmar Uhlig                                                                     │
│ See end of file for terms of use.                                                                    │
│ Die Nutzungsbedingungen befinden sich am Ende der Datei                                              │
└──────────────────────────────────────────────────────────────────────────────────────────────────────┘

Version:     0.01
Last Change: 2015-09-09

Log:
0.01, 2015-09-09: created

}}


' command line program tools

OBJ
  ios: "reg-ios"

VAR
  long usage_start
  long usage_end

PUB init(p_usage_start_addr, p_usage_end_addr)
  usage_start := p_usage_start_addr
  usage_end := p_usage_end_addr

PUB usage | i
  repeat i from 0 to usage_end - usage_start - 1
    ios.printchar(byte[usage_start][i])

PUB pr_err(txt, pr_usage)
  ios.print(string("ERROR: "))
  ios.print(txt)
  ios.printnl
  if pr_usage
    pr(string("usage: "))
    usage

PUB die(txt)
  pr_err(txt, 0)
  abort 100

PUB die_os(txt1, txt2, err)
  ios.print(string("ERROR: "))
  ios.print(txt1)
  ios.print(txt2)
  ios.printnl
  ios.os_error(err)
  abort 101

PUB pr(s)
  ios.print(s)
  ios.printnl

PUB W_I_P
  die(string("Work in progress"))


DAT

{{

┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
}}

