' mandelbrot-20170604

con
  maxiter=32
  c4=4<<24

obj
  ios: "reg-ios"

dat
' Transportable Constants
' Don't change the order!

  xmin  long  0
  xmax  long  0
  ymin  long  0
  ymax  long  0
  MPX   long  0
  MPY   long  0

dat
  dx          long      0       ' Delta-Z, x-Anteil
  dy          long      0       ' Delta-Z, y-Anteil


pub setvar(baseAddr, numLongs)
  longmove(@xmin, baseAddr, numLongs)

  dx := (xmax - xmin) / MPX
  dy := (ymax - ymin) / MPY


pub computeJ(ix, iy): color | cx, cy, x, y, xx, yy, rsq, iter
  ' Pixel -> Z
  cx := xmin + ix * dx
  cy := ymin + iy * dy

  ' Berechnung
  x := y := rsq := 0
  iter := maxiter
  repeat while iter and rsq =< c4
    xx := fpm(x, x)
    yy := fpm(y, y)
    y := 2 * fpm(x, y) + cy
    x := xx - yy + cx
    rsq := xx + yy
    iter--

  ' Farbauswahl
  if iter > 24
    color := 3
  elseif iter > 16
    color := 2
  elseif iter > 8
    color := 1
  else
    color := 0

con

'
'           AAAAAAAAaaaaaaaaaaaaaaaaaaaaaaaa
' *         BBBBBBBBbbbbbbbbbbbbbbbbbbbbbbbb
'           ================================
' = CCCCCCCCCCCCCCCCcccccccccccccccccccccccccccccccccccccccccccccccc
'   \______________  ______________/\______________  ______________/
'                  \/                              \/
'              SChi:=SA**SB                    SClo:=SA*SB
'
pri fpm(SA,SB) | SClo
  SClo:=(SA*SB)
  return (SA**SB)<<8 | SClo.byte[0]


